Oracle Coherence for C++ API
Release 3.6.0.0
E15728-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# InKeySetFilter Class Reference

`#include <coherence/util/filter/InKeySetFilter.hpp>`

Inherits Object, IndexAwareFilter, and PortableObject.

List of all members.

## Detailed Description

Filter that limits the underlying filter evaluation only to the specified set of keys.

Author:
  djl 2008.04.14

## Public Types
typedef spec::Handle | Handle
| InKeySetFilter Handle definition.
typedef spec::View | View
| InKeySetFilter View definition.
typedef spec::Holder | Holder
| InKeySetFilter Holder definition.
## Public Member Functions
virtual bool | evaluateEntry (Map::Entry::View vEntry) const
  | Apply the test to a Map::Entry. Parameters:
  | vEntry | the Map::Entry to evaluate; never NULL
Returns: true if the test passes, false otherwise
virtual bool | evaluate (Object::View v) const
  | Apply the test to the object. Parameters:
  | v | the object to test
Returns: true if the test passes, false otherwise
virtual size32_t | calculateEffectiveness (Map::View vMapIndexes, Set::View vSetKeys) const
  | Given a Map of available indexes, determine if this IndexAwareFilter can use any of the indexes to assist in its processing, and if so, determine how effective the use of that index would be. The returned value is an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys. An operation that requires no more than a single access to the index content (i.e. Equals, NotEquals) has an effectiveness of one. Evaluation of a single entry is assumed to have an effectiveness that depends on the index implementation and is usually measured as a constant number of the single operations. This number is referred to as evaluation cost. If the effectiveness of a filter evaluates to a number larger than the `keySet.size() * <evaluation cost>` then a user could avoid using the index and iterate through the keySet calling `evaluate` rather then `applyIndex`. Parameters:
  | vMapIndexes | the available MapIndex objects keyed by the related ValueExtractor; read-only
  | vSetKeys | the set of keys that will be filtered; read-only
Returns: an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys
virtual Filter::View | applyIndex (Map::View vMapIndexes, Set::Handle hSetKeys) const
  | Filter remaining keys using a Map of available indexes. The filter is responsible for removing all keys from the passed set of keys that the applicable indexes can prove should be filtered. If the filter does not fully evaluate the remaining keys using just the index information, it must return a filter (which may be an EntryFilter) that can complete the task using an iterating implementation. If, on the other hand, the filter does fully evaluate the remaining keys using just the index information, then it should return null to indicate that no further filtering is necessary. Parameters:
  | vMapIndexes | the available MapIndex objects keyed by the related ValueExtractor; read-only
  | hSetKeys | the mutable set of keys that remain to be filtered
Returns: a Filter object (which may be an EntryFilter) that can be used to process the remaining keys, or null if no additional filter processing is necessary
virtual void | readExternal (PofReader::Handle hIn)
virtual void | writeExternal (PofWriter::Handle hOut) const
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description
virtual Filter::View | getFilter () const
| Obtain the Filter.
virtual void | ensureConverted (Converter::View vConverter)
| Ensure that the underlying keys are converted using the specified converter.
## Protected Member Functions
| InKeySetFilter ()
| Default constructor (necessary for the PortableObject interface).
| InKeySetFilter (Filter::View vFilter, Set::View vSetKeys)
| Construct an InSetFilter for testing "In" condition.

## Constructor & Destructor Documentation

InKeySetFilter | ( | Filter::View | vFilter,
|  | Set::View | vSetKeys |
| ) |  |  | `[protected]`

Construct an InSetFilter for testing "In" condition.

Parameters:

  | vFilter | the underlying filter
  | vSetKeys | the set of keys to limit the filter evaluation to

## Member Function Documentation

virtual Filter::View getFilter | ( |  | ) | const `[virtual]`

Obtain the Filter.

Returns:
  the Filter

virtual void ensureConverted | ( | Converter::View | vConverter | ) | `[virtual]`

Ensure that the underlying keys are converted using the specified converter.

This method is intended to be used exclusively by the partitioned cache service in a scenario when cache keys to evaluate by this filter exist in internal form.

Parameters:

  | vConverter | the converter that should be used for key conversions

The documentation for this class was generated from the following file:

- coherence/util/filter/InKeySetFilter.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.